--[[

Copyright (C) LSSA Modding Team, All Rights Reserved.
All about secrets

@author: Northern_Strike(RUS) [LSSA Modding Team]
@site: http://lssa.ru/
@data: 10/02/13

--]]
MainSctiptForK744byLSSA = {};

function MainSctiptForK744byLSSA.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function MainSctiptForK744byLSSA:load(xmlFile)


	--kardan
	self.kardanActiv = true;

	self.kardan1 = Utils.indexToObject(self.components, "0>15");
	self.kardan2 = Utils.indexToObject(self.components, "1>16|0");
	self.kardan3 = Utils.indexToObject(self.components, "1>3|0");
	--kardan
	
local rotationPartNodeGas = Utils.indexToObject(self.components, "0>17|0|1|0");

    if rotationPartNodeGas ~= nil then
        self.rotationPartGas = {};
        self.rotationPartGas.node = rotationPartNodeGas;

        self.rotationPartGas.minRot = {};
        self.rotationPartGas.minRot[1] = Utils.degToRad(0);
        self.rotationPartGas.minRot[2] = Utils.degToRad(0);
        self.rotationPartGas.minRot[3] = Utils.degToRad(0);

        self.rotationPartGas.maxRot = {};
        self.rotationPartGas.maxRot[1] = Utils.degToRad(50);
        self.rotationPartGas.maxRot[2] = Utils.degToRad(0);
        self.rotationPartGas.maxRot[3] = Utils.degToRad(0);

        self.rotationPartGas.rotTime = 500;
        self.rotationPartGas.touchRotLimit = 10;
    end;

local rotationPartNodeTormoz = Utils.indexToObject(self.components, "0>17|0|2|0");

    if rotationPartNodeTormoz ~= nil then
        self.rotationPartTormoz = {};
        self.rotationPartTormoz.node = rotationPartNodeTormoz;

        self.rotationPartTormoz.minRot = {};
        self.rotationPartTormoz.minRot[1] = Utils.degToRad(0);
        self.rotationPartTormoz.minRot[2] = Utils.degToRad(0);
        self.rotationPartTormoz.minRot[3] = Utils.degToRad(0);

        self.rotationPartTormoz.maxRot = {};
        self.rotationPartTormoz.maxRot[1] = Utils.degToRad(50);
        self.rotationPartTormoz.maxRot[2] = Utils.degToRad(0);
        self.rotationPartTormoz.maxRot[3] = Utils.degToRad(0);

        self.rotationPartTormoz.rotTime = 1000;
        self.rotationPartTormoz.touchRotLimit = 10;
    end;
	
end;

function MainSctiptForK744byLSSA:mouseEvent(posX, posY, isDown, isUp, button)
end;


function MainSctiptForK744byLSSA:keyEvent(unicode, sym, modifier, isDown)
end;

function MainSctiptForK744byLSSA:update(dt)

--[[
if self.isMotorStarted then

	self.rotMax_Gaz = { (-1*(Utils.degToRad(0) - Utils.degToRad(50)) / 2050) * (self.motor.lastMotorRpm/1.5),Utils.degToRad(0),Utils.degToRad(0)};
	self.newRot_Gaz = Utils.getMovedLimitedValues({getRotation(self.GazRC)}, self.rotMax_Gaz, {Utils.degToRad(0),Utils.degToRad(0),Utils.degToRad(0)}, 1, 1000, dt, not self.toMax);
	setRotation(self.GazRC, unpack(self.newRot_Gaz));
	
else

	self.newRot_Gaz = Utils.getMovedLimitedValues({getRotation(self.GazRC)}, {Utils.degToRad(50),Utils.degToRad(0),Utils.degToRad(0)}, {Utils.degToRad(0),Utils.degToRad(0),Utils.degToRad(0)}, 1, 1000, dt, self.toMax);
	setRotation(self.GazRC, unpack(self.newRot_Gaz));

end;
--]]

if self.rotationPartGas ~= nil then
		local x, y, z = getRotation(self.rotationPartGas.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartGas.maxRot, self.rotationPartGas.minRot, 3, self.rotationPartGas.rotTime, dt, not self.rotationMaxGas);
		setRotation(self.rotationPartGas.node, unpack(newRot));
	end;

if self.rotationPartTormoz ~= nil then
		local x, y, z = getRotation(self.rotationPartTormoz.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartTormoz.maxRot, self.rotationPartTormoz.minRot, 3, self.rotationPartTormoz.rotTime, dt, not self.rotationMaxTormoz);
		setRotation(self.rotationPartTormoz.node, unpack(newRot));
	end;

	if self:getIsActive() then	

		inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);

        if InputBinding.isAxisZero(inputAxisY) then
        inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        end;
		
		if self.isEntered ~= nil then
			if (self.movingDirection*self.lastSpeed*(-inputAxisY)) < -0.001 then		
				self.rotationMaxTormoz = true;
			else
				self.rotationMaxTormoz = false;
			end;
		end;
	
		if self.rotationPartGas ~= nil and self.isMotorStarted == true then
			local x, y, z = getRotation(self.rotationPartGas.node);
			x = (-1*(self.rotationPartGas.minRot[1] - self.rotationPartGas.maxRot[1]) / 1200) * (self.motor.lastMotorRpm/1.5) + self.rotationPartGas.minRot[1];
			setRotation(self.rotationPartGas.node, x, y ,z);
		elseif self.isMotorStarted == false then
			setRotation(self.rotationPartGas.node, 0, 0 ,0);
		end;
	
	end;

--kardan
if self.kardanActiv then
	if self.isMotorStarted then
	   self.PointRot = getRotation(self.wheels[3].driveNode);
       setRotation(self.kardan1,0 ,0 ,self.PointRot);
       setRotation(self.kardan2,0 ,0 ,self.PointRot);
       setRotation(self.kardan3,0 ,0 ,self.PointRot);
	end;
end;
--kardan

end;

function MainSctiptForK744byLSSA:updateTick(dt)
end;

function MainSctiptForK744byLSSA:draw()

end;

function MainSctiptForK744byLSSA:delete()
end;